using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Grouping;

using TestGroupingGrid.CustomSummary;

namespace TestGroupingGrid
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private const string SUMMARY_ROW_NAME = "Totals";

		private const int DATA_ROWS = 10;//1000;
		private const string SELECTED = "Selected";
		private const string SECTOR = "Sector";
		private const string SECTOR_MAJOR = "Sector (Major)";
		private const string ASSET = "Asset";
		private const string CURRENCY = "Currency";		
		private const string POSITION = "Position";
		private const string POSITIONADJ = "PositionAdj";

		DataTable myTable;

		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		private System.Windows.Forms.CheckBox checkBox10;
		private System.Windows.Forms.CheckBox checkBox9;
		private System.Windows.Forms.CheckBox checkBox8;
		private System.Windows.Forms.CheckBox checkBox7;
		private System.Windows.Forms.CheckBox checkBox2;
		private System.Windows.Forms.CheckBox checkBox1;
		private System.Windows.Forms.CheckBox checkBox6;
		private System.Windows.Forms.CheckBox checkBox5;
		private System.Windows.Forms.CheckBox checkBox4;
		private System.Windows.Forms.CheckBox checkBox3;
		private System.Windows.Forms.Button expand;
		private System.Windows.Forms.CheckBox checkBox11;
		private System.Windows.Forms.CheckBox checkBox12;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.CheckBox checkBox13;
		private System.Windows.Forms.CheckBox checkBox14;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.checkBox10 = new System.Windows.Forms.CheckBox();
			this.checkBox9 = new System.Windows.Forms.CheckBox();
			this.checkBox8 = new System.Windows.Forms.CheckBox();
			this.checkBox7 = new System.Windows.Forms.CheckBox();
			this.checkBox2 = new System.Windows.Forms.CheckBox();
			this.checkBox1 = new System.Windows.Forms.CheckBox();
			this.checkBox6 = new System.Windows.Forms.CheckBox();
			this.checkBox5 = new System.Windows.Forms.CheckBox();
			this.checkBox4 = new System.Windows.Forms.CheckBox();
			this.checkBox3 = new System.Windows.Forms.CheckBox();
			this.expand = new System.Windows.Forms.Button();
			this.checkBox11 = new System.Windows.Forms.CheckBox();
			this.checkBox12 = new System.Windows.Forms.CheckBox();
			this.button1 = new System.Windows.Forms.Button();
			this.checkBox13 = new System.Windows.Forms.CheckBox();
			this.checkBox14 = new System.Windows.Forms.CheckBox();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.gridGroupingControl1.ChildGroupOptions.CaptionText = "{Category} ";
			this.gridGroupingControl1.Font = new System.Drawing.Font("Arial", 10F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.gridGroupingControl1.Location = new System.Drawing.Point(8, 8);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.ShowNavigationBar = true;
			this.gridGroupingControl1.ShowNavigationBarToolTips = true;
			this.gridGroupingControl1.Size = new System.Drawing.Size(784, 488);
			this.gridGroupingControl1.TabIndex = 11;
			this.gridGroupingControl1.TableDescriptor.AllowNew = false;
			this.gridGroupingControl1.TableDescriptor.AllowRemove = false;
			this.gridGroupingControl1.TableDescriptor.Name = "Default";
			this.gridGroupingControl1.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Cell | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.AlphaBlend)));
			this.gridGroupingControl1.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.None;
			this.gridGroupingControl1.TableOptions.ShowRowHeader = false;
			this.gridGroupingControl1.TableOptions.ShowTreeLines = true;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.TopLevelGroupOptions.ShowCaption = false;
			this.gridGroupingControl1.TableControlCurrentCellDeactivating += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCancelEventHandler(this.gridGroupingControl1_TableControlCurrentCellDeactivating);
			this.gridGroupingControl1.TableControlCurrentCellActivated += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlEventHandler(this.gridGroupingControl1_TableControlCurrentCellActivated);
			this.gridGroupingControl1.TableControlCurrentCellActivating += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellActivatingEventHandler(this.gridGroupingControl1_TableControlCurrentCellActivating);
			// 
			// checkBox10
			// 
			this.checkBox10.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.checkBox10.Location = new System.Drawing.Point(800, 232);
			this.checkBox10.Name = "checkBox10";
			this.checkBox10.Size = new System.Drawing.Size(152, 16);
			this.checkBox10.TabIndex = 37;
			this.checkBox10.Text = "AutohighLight Contents";
			this.checkBox10.CheckedChanged += new System.EventHandler(this.checkBox10_CheckedChanged);
			// 
			// checkBox9
			// 
			this.checkBox9.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.checkBox9.Location = new System.Drawing.Point(800, 216);
			this.checkBox9.Name = "checkBox9";
			this.checkBox9.Size = new System.Drawing.Size(104, 16);
			this.checkBox9.TabIndex = 36;
			this.checkBox9.Text = "Excel like selection";
			this.checkBox9.CheckedChanged += new System.EventHandler(this.checkBox9_CheckedChanged);
			// 
			// checkBox8
			// 
			this.checkBox8.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.checkBox8.Location = new System.Drawing.Point(800, 128);
			this.checkBox8.Name = "checkBox8";
			this.checkBox8.Size = new System.Drawing.Size(144, 16);
			this.checkBox8.TabIndex = 35;
			this.checkBox8.Text = "Apply Summary  Style";
			this.checkBox8.CheckedChanged += new System.EventHandler(this.checkBox8_CheckedChanged);
			// 
			// checkBox7
			// 
			this.checkBox7.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.checkBox7.Location = new System.Drawing.Point(800, 200);
			this.checkBox7.Name = "checkBox7";
			this.checkBox7.Size = new System.Drawing.Size(160, 16);
			this.checkBox7.TabIndex = 34;
			this.checkBox7.Text = "MergeCaptions";
			this.checkBox7.CheckedChanged += new System.EventHandler(this.checkBox7_CheckedChanged);
			// 
			// checkBox2
			// 
			this.checkBox2.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.checkBox2.Location = new System.Drawing.Point(800, 184);
			this.checkBox2.Name = "checkBox2";
			this.checkBox2.Size = new System.Drawing.Size(160, 16);
			this.checkBox2.TabIndex = 33;
			this.checkBox2.Text = "Set Asset Col Width";
			this.checkBox2.CheckedChanged += new System.EventHandler(this.checkBox2_CheckedChanged);
			// 
			// checkBox1
			// 
			this.checkBox1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.checkBox1.Location = new System.Drawing.Point(800, 112);
			this.checkBox1.Name = "checkBox1";
			this.checkBox1.Size = new System.Drawing.Size(160, 16);
			this.checkBox1.TabIndex = 32;
			this.checkBox1.Text = "Apply DataRow Style";
			this.checkBox1.CheckedChanged += new System.EventHandler(this.checkBox1_CheckedChanged);
			// 
			// checkBox6
			// 
			this.checkBox6.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.checkBox6.Location = new System.Drawing.Point(800, 96);
			this.checkBox6.Name = "checkBox6";
			this.checkBox6.Size = new System.Drawing.Size(160, 16);
			this.checkBox6.TabIndex = 31;
			this.checkBox6.Text = "Apply CheckBox Style";
			this.checkBox6.CheckedChanged += new System.EventHandler(this.checkBox6_CheckedChanged);
			// 
			// checkBox5
			// 
			this.checkBox5.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.checkBox5.Location = new System.Drawing.Point(800, 80);
			this.checkBox5.Name = "checkBox5";
			this.checkBox5.Size = new System.Drawing.Size(160, 16);
			this.checkBox5.TabIndex = 30;
			this.checkBox5.Text = "Apply Column Style";
			this.checkBox5.CheckedChanged += new System.EventHandler(this.checkBox5_CheckedChanged);
			// 
			// checkBox4
			// 
			this.checkBox4.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.checkBox4.Location = new System.Drawing.Point(800, 32);
			this.checkBox4.Name = "checkBox4";
			this.checkBox4.Size = new System.Drawing.Size(160, 16);
			this.checkBox4.TabIndex = 29;
			this.checkBox4.Text = "Apply Grouping Style";
			this.checkBox4.CheckedChanged += new System.EventHandler(this.checkBox4_CheckedChanged);
			// 
			// checkBox3
			// 
			this.checkBox3.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.checkBox3.Location = new System.Drawing.Point(800, 8);
			this.checkBox3.Name = "checkBox3";
			this.checkBox3.Size = new System.Drawing.Size(152, 16);
			this.checkBox3.TabIndex = 28;
			this.checkBox3.Text = "Child Group Full Captions";
			this.checkBox3.CheckedChanged += new System.EventHandler(this.checkBox3_CheckedChanged);
			// 
			// expand
			// 
			this.expand.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.expand.Location = new System.Drawing.Point(800, 472);
			this.expand.Name = "expand";
			this.expand.Size = new System.Drawing.Size(24, 23);
			this.expand.TabIndex = 38;
			this.expand.Text = "+";
			this.expand.Click += new System.EventHandler(this.expand_Click);
			// 
			// checkBox11
			// 
			this.checkBox11.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.checkBox11.Location = new System.Drawing.Point(800, 48);
			this.checkBox11.Name = "checkBox11";
			this.checkBox11.Size = new System.Drawing.Size(160, 16);
			this.checkBox11.TabIndex = 39;
			this.checkBox11.Text = "Apply Any Grouping Style";
			this.checkBox11.CheckedChanged += new System.EventHandler(this.checkBox11_CheckedChanged);
			// 
			// checkBox12
			// 
			this.checkBox12.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.checkBox12.Location = new System.Drawing.Point(800, 144);
			this.checkBox12.Name = "checkBox12";
			this.checkBox12.Size = new System.Drawing.Size(144, 16);
			this.checkBox12.TabIndex = 40;
			this.checkBox12.Text = "Set Background Colour";
			this.checkBox12.CheckedChanged += new System.EventHandler(this.checkBox12_CheckedChanged);
			// 
			// button1
			// 
			this.button1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.button1.Location = new System.Drawing.Point(832, 472);
			this.button1.Name = "button1";
			this.button1.TabIndex = 41;
			this.button1.Text = "button1";
			this.button1.Click += new System.EventHandler(this.button1_Click_1);
			// 
			// checkBox13
			// 
			this.checkBox13.Location = new System.Drawing.Point(800, 248);
			this.checkBox13.Name = "checkBox13";
			this.checkBox13.Size = new System.Drawing.Size(144, 16);
			this.checkBox13.TabIndex = 42;
			this.checkBox13.Text = "Use a Custom summary";
			this.checkBox13.CheckedChanged += new System.EventHandler(this.checkBox13_CheckedChanged);
			// 
			// checkBox14
			// 
			this.checkBox14.Location = new System.Drawing.Point(800, 264);
			this.checkBox14.Name = "checkBox14";
			this.checkBox14.Size = new System.Drawing.Size(144, 16);
			this.checkBox14.TabIndex = 43;
			this.checkBox14.Text = "Format Decimal Places";
			this.checkBox14.CheckedChanged += new System.EventHandler(this.checkBox14_CheckedChanged);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(952, 501);
			this.Controls.Add(this.checkBox14);
			this.Controls.Add(this.checkBox13);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.checkBox12);
			this.Controls.Add(this.checkBox11);
			this.Controls.Add(this.expand);
			this.Controls.Add(this.checkBox10);
			this.Controls.Add(this.checkBox9);
			this.Controls.Add(this.checkBox8);
			this.Controls.Add(this.checkBox7);
			this.Controls.Add(this.checkBox2);
			this.Controls.Add(this.checkBox1);
			this.Controls.Add(this.checkBox6);
			this.Controls.Add(this.checkBox5);
			this.Controls.Add(this.checkBox4);
			this.Controls.Add(this.checkBox3);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			try
			{
				Application.Run(new Form1());
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.ToString());
			}
		}

		private void gridGroupingControl1_ContextMenuChanged(object sender, System.EventArgs e)
		{
		
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			//get a DataTable
			myTable = GetATable();

			// GRID 3
			this.gridGroupingControl1.DataSource = myTable;
			this.gridGroupingControl1.TableDescriptor.GroupedColumns.Add(SECTOR_MAJOR);
			this.gridGroupingControl1.TableDescriptor.GroupedColumns.Add(SECTOR);
			this.gridGroupingControl1.TableDescriptor.GroupedColumns.Add(CURRENCY);


			Syncfusion.Grouping.SortColumnDescriptor sortBy = new Syncfusion.Grouping.SortColumnDescriptor(ASSET);
			this.gridGroupingControl1.TableDescriptor.SortedColumns.Add(sortBy);

			gridGroupingControl1.TableOptions.ColumnHeaderRowHeight = 32;//25 by default givs us room for 2 lines

			// Select only one at a time
			//gridGroupingControl1.TableDescriptor.TableOptions.ListBoxSelectionMode = SelectionMode.One;
			//gridGroupingControl1.TableOptions.AllowSelection |= GridSelectionFlags.AlphaBlend | GridSelectionFlags.Row;
  
			// make everhytitng Static for readonly - need to alter the adjsuted cols
			//gridGroupingControl1.TableDescriptor.Appearance.AnyRecordFieldCell.CellType = "Static";

			// Hide the corder around the current cell - looks naff on readonyl
			//gridGroupingControl1.TableModel.Options.ShowCurrentCellBorderBehavior = GridShowCurrentCellBorder.HideAlways;

			//color rows and alternates rows if they are selected
			//			GridConditionalFormatDescriptor formatSelected = new GridConditionalFormatDescriptor("selected");
			//			formatSelected.Expression = "[SELECTED] == true";
			//			formatSelected.Appearance.AlternateRecordFieldCell.BackColor = Color.Blue;
			//			formatSelected.Appearance.AnyRecordFieldCell.BackColor = Color.Blue;
			//			gridGroupingControl1.TableDescriptor.ConditionalFormats.Add(formatSelected);
			
			CreateSummaryColumns();
			//toolTip1.SetToolTip(this.gridGroupingControl1, "My button1");

		}

		private void CreateSummaryColumns()
		{
			GridTableDescriptor tdParent = gridGroupingControl1.TableDescriptor;
			GridTableDescriptor tdChild = tdParent;

			//add summary row to child
			//GridSummaryColumnDescriptor[] sumCols = new GridSummaryColumnDescriptor[2];
			GridSummaryColumnDescriptor posSummary = new GridSummaryColumnDescriptor(POSITION);
			posSummary.DataMember = POSITION;
			posSummary.DisplayColumn = POSITION;
			posSummary.Style = GridSummaryStyle.Column;
			posSummary.Format = "{Sum:#.00}";
			posSummary.SummaryType = SummaryType.DoubleAggregate;

			GridSummaryColumnDescriptor posAdjSummary = new GridSummaryColumnDescriptor(POSITIONADJ);
			posAdjSummary.DataMember = POSITIONADJ;
			posAdjSummary.DisplayColumn = POSITIONADJ;
			posAdjSummary.Style = GridSummaryStyle.Column;
			posAdjSummary.Format = "{Sum:#.00}";
			posAdjSummary.SummaryType = SummaryType.DoubleAggregate;
			//sumCols[1] = posAdjSummary;

			//GridSummaryRowDescriptor sRow = new GridSummaryRowDescriptor(SUMMARY_ROW_NAME, sumCols);
			GridSummaryRowDescriptor sRow = new GridSummaryRowDescriptor(SUMMARY_ROW_NAME);
			sRow.SummaryColumns.AddRange(new GridSummaryColumnDescriptor[] {posSummary, posAdjSummary});
			sRow.Visible = false;
			tdChild.SummaryRows.Add(sRow);
			tdChild.Appearance.AnySummaryCell.HorizontalAlignment = GridHorizontalAlignment.Right;

			tdParent.SummaryRows.Add(sRow);
			//tdParent.Columns[SECTOR_MAJOR].GroupByAppearance.GroupCaptionSummaryCell.BackColor = Color.Red; //tdParent.Appearance.RecordFieldCell.BackColor;
			//			tdParent.Columns[SECTOR_MAJOR].GroupByAppearance.GroupCaptionCell.CellType = "Static";
			//			tdParent.Columns[SECTOR_MAJOR].GroupByAppearance.AnyGroupCell.VerticalAlignment = GridVerticalAlignment.Middle;
			//			tdParent.Columns[SECTOR_MAJOR].GroupByAppearance.GroupCaptionCell.Borders.All = new GridBorder(GridBorderStyle.Standard);

			tdParent.ChildGroupOptions.CaptionText = "{Category}";
			tdParent.ChildGroupOptions.ShowCaptionSummaryCells = true;
			tdParent.ChildGroupOptions.CaptionSummaryRow = SUMMARY_ROW_NAME;

			gridGroupingControl1.TableOptions.ShowTableRowHeaderAsCoveredRange = true;

		}

		private DataTable GetATable()
		{
			DataTable dt = new DataTable("MyTable");
			
			dt.Columns.Add(new DataColumn(SECTOR_MAJOR, typeof(string)));
			dt.Columns.Add(new DataColumn(SECTOR, typeof(string)));
			dt.Columns.Add(new DataColumn(CURRENCY, typeof(string)));
			dt.Columns.Add(new DataColumn(ASSET, typeof(string)));
			dt.Columns.Add(new DataColumn(SELECTED, typeof(bool)));
			dt.Columns.Add(new DataColumn(POSITION, typeof(double)));		
			dt.Columns.Add(new DataColumn(POSITIONADJ, typeof(double)));		

			PopulateDataTable(dt);

			return dt;
		}

		private void PopulateDataTable(DataTable dt)
		{
			//			if (this.gridGroupingControl1.TableModel.cur.CreateControl.CurrentRowIndex >= 0)
			//				this.dataGrid1.CurrentRowIndex = 0;
			dt.Clear();
			dt.Rows.Clear();

			Random r = new Random();

			for(int i = 0; i < DATA_ROWS; i++)
			{
				DataRow dr = dt.NewRow();
	
				string sectorMajor = "";
				string sector = "";

				string asset = "";
				switch (r.Next(5))
				{
					case 0:
						asset = "MS 07/15/09";
						break;
					case 1:
						asset = "BT 05/15/08";
						break;
					case 2:
						asset = "EMAP";
						break;
					case 3:
						asset = "ALLIED 0% 03-01-14";
						break;
					case 4:
						asset = "CELL  08-01-11";
						break;
					default:
						asset = "ABIT INC 08-01-09";
						break;
				}
				asset += " " + i.ToString("00000");

				switch (r.Next(3))
				{
					case 0:
						sectorMajor = "Asset Backed";
					switch (r.Next(3))
					{
						case 0:
							sector = "Asset Back Securities";
							break;
						case 1:
							sector = "Credit Card";
							break;
						default:
							sector = "Other";
							break;
					}
						break;

					case 1:
						sectorMajor = "Corporates";
					switch (r.Next(3))
					{
						case 0:
							sector = "Automobiles & Components";
							break;
						case 1:
							sector = "Banks";
							break;
						default:
							sector = "Captial Goods";
							break;
					}
						break;

					default:
						sectorMajor = "Mortgage Backed";
					switch (r.Next(3))
					{
						case 0:
							sector = "Mortgage-Backed Securities";
							break;
						case 1:
							sector = "Public Sector";
							break;
						case 2:
							sector = "Private Sector";
							break;
					}
						break;
				}

				string currency = "";
				switch (r.Next(3))
				{
					case 0:
						currency = "USD";
						break;
					case 1:
						currency = "EURO";
						break;
					case 2:
						currency = "GBP";
						break;
				}

				dr[SECTOR_MAJOR] = sectorMajor;
				dr[SECTOR] = sector;
				dr[ASSET] = asset;
				dr[CURRENCY] = currency;

				int itemPosition = r.Next(1000);
				dr[POSITION] = itemPosition + 0.13;

				// adjust pos for first 10
				if (i< 10)
				{
					dr[POSITIONADJ] = itemPosition + i;
				}

				dt.Rows.Add(dr);
			}
		}

		private void ResetStyle(Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfo style)
		{
			style.ResetInterior();
			style.ResetCellType();
			style.ResetFont();
			style.ResetHorizontalAlignment();
		}

		private void checkBox3_CheckedChanged(object sender, System.EventArgs e)
		{
			string caption;
			if (checkBox3.Checked)
			{
				caption = "{CategoryName}: {Category}";
			}
			else
			{
				caption = "{Category}";
			}

			//gridGroupingControl1.ChildGroupOptions.CaptionText = caption;
			GridTableDescriptor tdParent = gridGroupingControl1.TableDescriptor;
			tdParent.ChildGroupOptions.CaptionText = caption;//"{Category}";
		}

		private void checkBox4_CheckedChanged(object sender, System.EventArgs e)
		{
			if (checkBox4.Checked)
			{
				GridTableCellStyleInfo newStyle = new GridTableCellStyleInfo();
				newStyle.BackColor = Color.Wheat;
				newStyle.Enabled = false;
				newStyle.ReadOnly = true;
				newStyle.Font.Bold = true;

				//gridGroupingControl1.TableDescriptor.Appearance.AnyGroupCell = newStyle;
				gridGroupingControl1.TableDescriptor.Appearance.GroupCaptionCell = newStyle;
				gridGroupingControl1.TableDescriptor.Appearance.GroupCaptionSummaryCell = newStyle;
			

			}
			else
			{
				ResetStyle(gridGroupingControl1.TableDescriptor.Appearance.GroupCaptionCell);
				ResetStyle(gridGroupingControl1.TableDescriptor.Appearance.GroupCaptionSummaryCell);
			}

		}

		private void checkBox5_CheckedChanged(object sender, System.EventArgs e)
		{
			// column headers
			if (checkBox5.Checked)
			{
				GridTableCellStyleInfo newStyle = new GridTableCellStyleInfo();
				newStyle.CellAppearance = GridCellAppearance.Raised;
				newStyle.BackColor = Color.Silver;
				newStyle.Font.Bold = true;
				gridGroupingControl1.TableDescriptor.Appearance.ColumnHeaderCell = newStyle;
			}
			else
			{
				ResetStyle(gridGroupingControl1.TableDescriptor.Appearance.ColumnHeaderCell);
			}		

		}

		private void checkBox6_CheckedChanged(object sender, System.EventArgs e)
		{
			gridGroupingControl1.TableDescriptor.Columns[SELECTED].Width = 20;
			gridGroupingControl1.TableDescriptor.Columns[SELECTED].HeaderText ="Select";
			gridGroupingControl1.TableDescriptor.Columns[SELECTED].Appearance.AnyRecordFieldCell.CellType = "CheckBox";

		}

		private void checkBox1_CheckedChanged(object sender, System.EventArgs e)
		{
			if (checkBox1.Checked)
			{
				GridTableCellStyleInfo recordStyle = new GridTableCellStyleInfo();
				recordStyle.BackColor = Color.LightCyan;//.PowderBlue;
				recordStyle.Font.Bold = false;
				gridGroupingControl1.TableDescriptor.Appearance.RecordFieldCell = recordStyle;

				GridTableCellStyleInfo altRecordStyle = new GridTableCellStyleInfo();
				altRecordStyle.BackColor = Color.LightCyan;
				altRecordStyle.Font.Bold = false;
				gridGroupingControl1.TableDescriptor.Appearance.AlternateRecordFieldCell = altRecordStyle;

			}
			else
			{
				ResetStyle(gridGroupingControl1.TableDescriptor.Appearance.RecordFieldCell);
				ResetStyle(gridGroupingControl1.TableDescriptor.Appearance.AlternateRecordFieldCell);
			}			

		}

		private void checkBox2_CheckedChanged(object sender, System.EventArgs e)
		{
			if (checkBox2.Checked)
			{
				gridGroupingControl1.TableDescriptor.Columns[ASSET].Width = 450;
			}
			else
			{
				gridGroupingControl1.TableDescriptor.Columns[ASSET].Reset();

			}
		}

		private void checkBox7_CheckedChanged(object sender, System.EventArgs e)
		{
			gridGroupingControl1.TableModel.CoveredRanges.Clear();

			if (checkBox7.Checked)
			{
				gridGroupingControl1.TableDescriptor.Columns[POSITION].HeaderText = "2219 ADG AHIT";

				this.gridGroupingControl1.TableModel.QueryCoveredRange += 
					new Syncfusion.Windows.Forms.Grid.GridQueryCoveredRangeEventHandler(TableModel_QueryCoveredRange);
			}
			else
			{
				this.gridGroupingControl1.TableModel.QueryCoveredRange -= 
					new Syncfusion.Windows.Forms.Grid.GridQueryCoveredRangeEventHandler(TableModel_QueryCoveredRange);
			}
			
			gridGroupingControl1.Refresh();

		}

		private void TableModel_QueryCoveredRange(object sender, GridQueryCoveredRangeEventArgs e)
		{
			GridTableModel tm = sender as GridTableModel;
			Element el = tm.Table.DisplayElements[e.RowIndex];

			if (el is CaptionRow)
			{
				GridTableCellStyleInfo style = tm[e.RowIndex, e.ColIndex];
				int maxCaptionColCount = Math.Max(tm.Table.TableDescriptor.GetColumnIndentCount(), tm.Table.TableDescriptor.GetColCount()-1);
				int startCol = el.GroupLevel+1;
				maxCaptionColCount = Math.Min(5+1, maxCaptionColCount);
				IGridGroupOptionsSource g = el.ParentGroup as IGridGroupOptionsSource;
				if (g != null && !g.GroupOptions.ShowCaptionPlusMinus)
				{
					startCol--;
				}
				int d = (el.ParentTable.RelatedTables.Count > 0) ? 1 : 0;
				if (!((GridTable) el.ParentTable).TableOptions.ShowRecordPlusMinus)
					d = 0;
				if (e.ColIndex >= startCol && e.ColIndex <= maxCaptionColCount)
				{
					e.Range = GridRangeInfo.Cells(e.RowIndex, startCol, e.RowIndex, maxCaptionColCount);
					e.Handled = true;
				}
			}

		}

		private void checkBox8_CheckedChanged(object sender, System.EventArgs e)
		{
			if (checkBox8.Checked)
			{
				GridTableCellStyleInfo newStyle = new GridTableCellStyleInfo();
				//newStyle.CellAppearance = GridCellAppearance.Raised;
				newStyle.BackColor = Color.Red;
				//newStyle.Font.Bold = true;
				gridGroupingControl1.TableDescriptor.Appearance.AnySummaryCell = newStyle;
			}
			else
			{
				ResetStyle(gridGroupingControl1.TableDescriptor.Appearance.AnySummaryCell);
			}	

		}

		private void checkBox9_CheckedChanged(object sender, System.EventArgs e)
		{
			gridGroupingControl1.TableOptions.AllowSelection = GridSelectionFlags.Any;
			gridGroupingControl1.TableModel.Options.ExcelLikeSelectionFrame = true; 
			gridGroupingControl1.TableModel.Options.ExcelLikeCurrentCell = true; 
			gridGroupingControl1.TableControl.ExcelLikeFrameSelections 
				= new GridPaintExcelLikeSelection(this.gridGroupingControl1.TableControl);

		}

		private void expand_Click(object sender, System.EventArgs e)
		{
			gridGroupingControl1.Table.ExpandAllGroups();
		}

		private void checkBox11_CheckedChanged(object sender, System.EventArgs e)
		{
			if (checkBox11.Checked)
			{
				GridTableCellStyleInfo newStyle = new GridTableCellStyleInfo();
				newStyle.BackColor = this.BackColor;
				newStyle.Enabled = false;
				newStyle.ReadOnly = true;
				newStyle.Font.Bold = true;

				gridGroupingControl1.TableDescriptor.Appearance.AnyGroupCell = newStyle;
			}
			else
			{
				ResetStyle(gridGroupingControl1.TableDescriptor.Appearance.AnyGroupCell);
			}

		}

		private void checkBox12_CheckedChanged(object sender, System.EventArgs e)
		{
			if (checkBox12.Checked)
			{
				gridGroupingControl1.TableControl.BackColor = this.BackColor;
			}
			else
			{
				gridGroupingControl1.TableControl.BackColor = Color.White;
			}
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
		
		}

		private void button1_Click_1(object sender, System.EventArgs e)
		{
			string format = "#,##0.00;-#,##0.00; ";
			double val = 0;
			MessageBox.Show(val.ToString(format));
		}

		private void gridGroupingControl1_QueryCustomSummary(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridQueryCustomSummaryEventArgs e)
		{
			switch (e.SummaryColumn.Name)
			{
				case "QuantityTotal":
				{
					e.SummaryDescriptor.CreateSummaryMethod = new CreateSummaryDelegate(TotalSummary.CreateSummaryMethod);
					break;
				}
			}
		}

		private void checkBox13_CheckedChanged(object sender, System.EventArgs e)
		{
			const string CUSTOM_NAME = "QuantityTotal";

			GridTableDescriptor tableDescriptor = gridGroupingControl1.TableDescriptor;

			if (checkBox13.Checked)
			{
				this.gridGroupingControl1.QueryCustomSummary += new GridQueryCustomSummaryEventHandler(gridGroupingControl1_QueryCustomSummary);
				//			posAdjSummary.DataMember = POSITIONADJ;
				//			posAdjSummary.DisplayColumn = POSITIONADJ;
				//			posAdjSummary.Style = GridSummaryStyle.Column;
				//			posAdjSummary.Format = "{Sum:#.00}";
				//			posAdjSummary.SummaryType = SummaryType.DoubleAggregate;
				//

				GridSummaryColumnDescriptor sd1 = new GridSummaryColumnDescriptor(CUSTOM_NAME);
				//sd1.Name = "QuantityTotal";
				sd1.DataMember = POSITION;
				sd1.DisplayColumn = POSITION;
				sd1.Format = "{Total}";
				sd1.SummaryType = SummaryType.Custom;			

				tableDescriptor.SummaryRows[SUMMARY_ROW_NAME].SummaryColumns.Add(sd1);
                //this.gridGroupingControl1.TableDescriptor.SummaryRows.Add(new GridSummaryRowDescriptor("Row 1", "Total", sd1));

			}
			else
			{
				this.gridGroupingControl1.QueryCustomSummary -= new GridQueryCustomSummaryEventHandler(gridGroupingControl1_QueryCustomSummary);
				if (this.gridGroupingControl1.TableDescriptor.SummaryRows.Contains(CUSTOM_NAME))
				{
					this.gridGroupingControl1.TableDescriptor.SummaryRows.Remove(CUSTOM_NAME);
				}

			}

			this.gridGroupingControl1.Refresh();
		}

		private void checkBox14_CheckedChanged(object sender, System.EventArgs e)
		{
			string format = null;
			if (checkBox14.Checked)
			{
				format = "#,##0.00";
			}
			gridGroupingControl1.TableDescriptor.Columns[POSITION].Appearance.AnyRecordFieldCell.Format = format;
		}

		private void checkBox10_CheckedChanged(object sender, System.EventArgs e)
		{
		
		}

		private void gridGroupingControl1_TableControlCurrentCellActivated(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlEventArgs e)
		{
			System.Diagnostics.Debug.WriteLine("TableControlCurrentCellActivated:" + DateTime.Now);		
			GridControlBase grid = (GridControlBase)gridGroupingControl1.TableControl;
			GridCurrentCell currentCell = grid.CurrentCell;
			//GridTextBoxControl tb = currentCell.Renderer.Control as GridTextBoxControl;
			GridTextBoxCellRenderer tb = currentCell.Renderer as GridTextBoxCellRenderer;
			try
			{
				if (tb != null)
				{
					//tb.TextBox.Text = grid.Model.GetCellsInfo(currentCell.RangeInfo)[0].Text;
					//tb.TextBox.Text = gridPosition.GetCellsInfo(cc.RangeInfo)[0].Text;
					tb.TextBox.SelectAll();
				}
			}
			catch(Exception ex)
			{
				System.Diagnostics.Debug.WriteLine(ex.ToString());
			}
		}

		private void gridGroupingControl1_TableControlCurrentCellActivating(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellActivatingEventArgs e)
		{
			
			System.Diagnostics.Debug.WriteLine("TableControlCurrentCellActivating:" + DateTime.Now);		
		}

		private void gridGroupingControl1_TableControlCurrentCellDeactivating(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCancelEventArgs e)
		{
			System.Diagnostics.Debug.WriteLine("TableControlCurrentCellDeactivating:" + DateTime.Now);		
//			GridControlBase grid = (GridControlBase)gridGroupingControl1.TableControl;
//			GridCurrentCell currentCell = grid.CurrentCell;
//			//GridTextBoxControl tb = currentCell.Renderer.Control as GridTextBoxControl;
//			GridTextBoxCellRenderer tb = currentCell.Renderer as GridTextBoxCellRenderer;
//			GridCurrentCell cc = gridGroupingControl1.TableModel.HasCurrentCellInfo.  ..Table.cuModel.cu.Model.CurrentCell;
//			try
//			{
//				GridTextBoxCellRenderer tb = (GridTextBoxCellRenderer) cc.Renderer;
//				tb.TextBox.Text = gridPosition.GetCellsInfo(cc.RangeInfo)[0].Text;
//				tb.TextBox.SelectAll();
//			} 
//			catch{}
		}

	}
}
